Chromium Code Reviews
Help | Chromium Project | Gerrit Changes | Sign in
(8)

Issue 2045293002: Add support for multiple frames in SkCodec (Closed)

Created:
3 years, 6 months ago by scroggo_chromium
Modified:
3 years, 1 month ago
CC:
reviews_skia.org
Base URL:
https://skia.googlesource.com/skia.git@master
Target Ref:
refs/heads/master
Project:
skia
Visibility:
Public.

Description

Add support for multiple frames in SkCodec Add an interface to decode frames beyond the first in SkCodec, and add an implementation for SkGifCodec. Add getFrameData to SkCodec. This method reads ahead in the stream to return a vector containing meta data about each frame in the image. This is not required in order to decode frames beyond the first, but it allows a client to learn extra information: - how long the frame should be displayed - whether a frame should be blended with a prior frame, allowing the client to provide the prior frame to speed up decoding Add a new fields to SkCodec::Options: - fFrameIndex - fHasPriorFrame The API is designed so that SkCodec never caches frames. If a client wants a frame beyond the first, they specify the frame in Options.fFrameIndex. If the client does not have the frame's required frame (the frame that this frame must be blended on top of) cached, they pass false for Options.fHasPriorFrame. Unless the frame is independent, the codec will then recursively decode all frames necessary to decode fFrameIndex. If the client has the required frame cached, they can put it in the dst they pass to the codec, and the codec will only draw fFrameIndex onto it. Replace SkGifCodec's scanline decoding support with progressive decoding, and update the tests accordingly. Implement new APIs in SkGifCodec. Instead of using gif_lib, use GIFImageReader, imported from Chromium (along with its copyright headers) with the following changes: - SkGifCodec is now the client - Replace blink types - Combine GIFColorMap::buildTable and ::getTable into a method that creates and returns an SkColorTable - Input comes from an SkStream, instead of a SegmentReader. Add SkStreamBuffer, which buffers the (potentially partial) stream in order to decode progressively. (FIXME: This requires copying data that previously was read directly from the SegmentReader. Does this hurt performance? If so, can we fix it?) - Remove UMA code - Instead of reporting screen width and height to the client, allow the client to query for it - Fail earlier if the first frame AND screen have size of zero - Compute required previous frame when adding a new one - Move GIFParseQuery from GIFImageDecoder to GIFImageReader - Allow parsing up to a specific frame (to skip parsing the rest of the stream if a client only wants the first frame) - Compute whether the first frame has alpha and supports index 8, to create the SkImageInfo. This happens before reporting that the size has been decoded. Add GIFImageDecoder::haveDecodedRow to SkGifCodec, imported from Chromium (along with its copyright header), with the following changes: - Add support for sampling - Use the swizzler - Keep track of the rows decoded - Do *not* keep track of whether we've seen alpha Remove SkCodec::kOutOfOrder_SkScanlineOrder, which was only used by GIF scanline decoding. Call onRewind even if there is no stream (SkGifCodec needs to clear its decoded state so it will decode from the beginning). Add a method to SkSwizzler to access the offset into the dst, taking subsetting into account. Add a GM that animates a GIF. Add tests for the new APIs. *** Behavior changes: * Previously, we reported that an image with a subset frame and no transparent index was opaque and used the background index (if present) to fill the background. This is necessary in order to support index 8, but it does not match viewers/browsers I have seen. Examples: - Chromium and Gimp render the background transparent - Firefox, Safari, Linux Image Viewer, Safari Preview clip to the frame (for a single frame image) This CL matches Chromium's behavior and renders the background transparent. This allows us to have consistent behavior across products and simplifies the code (relative to what we would have to do to continue the old behavior on Android). It also means that we will no longer support index 8 for some GIFs. * Stop checking for GIFSTAMP - all GIFs should be either 89a or 87a. This matches Chromium. I suspect that bugs would have been reported if valid GIFs started with "GIFVER" instead of "GIF89a" or "GIF87a" (but did not decode in Chromium). *** Future work not included in this CL: * Move some checks out of haveDecodedRow, since they are the same for the entire frame e.g. - intersecting the frameRect with the full image size - whether there is a color table * Change when we write transparent pixels - In some cases, Chromium deemed this unnecessary, but I suspect it is slower than the fallback case. There will continue to be cases where we should *not* write them, but for e.g. the first pass where we have already cleared to transparent (which we may also be able to skip) writing the transparent pixels will not make anything incorrect. * Report color type and alpha type per frame - Depending on alpha values, disposal methods, frame rects, etc, subsequent frames may have different properties than the first. * Skip copies of the encoded data - We copy the encoded data in case the stream is one that cannot be rewound, so we can parse and then decode (possibly not immediately). For some input streams, this is unnecessary. - I was concerned this cause a performance regression, but on average the new code is faster than the old for the images I tested [1]. - It may cause a performance regression for Chromium, though, where we can always move back in the stream, so this should be addressed. Design doc: https://docs.google.com/a/google.com/document/d/12Qhf9T92MWfdWujQwCIjhCO3sw6pTJB5pJBwDM1T7Kc/ [1] https://docs.google.com/a/google.com/spreadsheets/d/19V-t9BfbFw5eiwBTKA1qOBkZbchjlTC5EIz6HFy-6RI/ GOLD_TRYBOT_URL= https://gold.skia.org/search2?unt=true&query=source_type%3Dgm&master=false&issue=2045293002 Committed: https://skia.googlesource.com/skia/+/19b91531e912283d237435d94516575b28713cba

Patch Set 1 #

Patch Set 2 : Rebase; new API #

Total comments: 24

Patch Set 3 : Move frame options into its own struct #

Patch Set 4 : Cache all frames in the GM #

Total comments: 27

Patch Set 5 : Fix up a comment #

Patch Set 6 : Return metadata in a vector #

Total comments: 1

Patch Set 7 : Small cleanups #

Total comments: 4

Patch Set 8 : Store duration in ms #

Patch Set 9 : Multiply last #

Patch Set 10 : Rebase. Fix durations in test. #

Patch Set 11 : Import GIFImageReader plus callback, unchanged from Chromium #

Patch Set 12 : Add constants to SkCodecAnimation.h #

Patch Set 13 : Integrate GIFImageReader with SkGifCodec #

Patch Set 14 : Various fixes #

Total comments: 32

Patch Set 15 : Respond to comments #

Total comments: 16

Patch Set 16 : Rebase on top of 2420843003 #

Patch Set 17 : Respond to comments #

Patch Set 18 : If BUILD needs SkGifCodec, it needs GIFImageReader #

Total comments: 2

Patch Set 19 : Format BUILD.gn properly #

Total comments: 2

Patch Set 20 : Don't need giflib for SkGifCodec anymore #

Total comments: 1

Patch Set 21 : Rebase #

Patch Set 22 : Fixes for BUILD.gn #

Patch Set 23 : Work around compiler error #

Patch Set 24 : Change kIndependentFrame to kNone #

Patch Set 25 : Never use background index. Sometimes recommend N32 #

Total comments: 1

Patch Set 26 : Disable DNG if Raw is disabled #

Total comments: 4

Patch Set 27 : Move MultiFrameOptions directly into Options #

Patch Set 28 : Respond to comments #

Patch Set 29 : Fix a typo #

Patch Set 30 : Rebase #

Patch Set 31 : Move GIFImageReader to third_party #

Patch Set 32 : Mark override #

Patch Set 33 : Stop preventing copy elision #

Patch Set 34 : \#include <alorithm> for std::min #

Patch Set 35 : Include algorithm elsewhere #

Patch Set 36 : Fix a test - we now draw transparent background for missing color table #

Unified diffs Side-by-side diffs Delta from patch set Stats (+2775 lines, -728 lines) Patch
M BUILD.gn View 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 7 chunks +5 lines, -14 lines 0 comments Download
M cmake/CMakeLists.txt View 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 1 chunk +0 lines, -1 line 0 comments Download
M dm/DM.cpp View 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 4 chunks +17 lines, -2 lines 0 comments Download
M dm/DMSrcSink.h View 1 2 3 4 5 6 7 8 9 10 11 12 1 chunk +1 line, -0 lines 0 comments Download
M dm/DMSrcSink.cpp View 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 6 chunks +75 lines, -18 lines 0 comments Download
M fuzz/fuzz.cpp View 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 1 chunk +0 lines, -11 lines 0 comments Download
A gm/animatedGif.cpp View 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 1 chunk +185 lines, -0 lines 0 comments Download
M gyp/codec.gyp View 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 4 chunks +4 lines, -1 line 0 comments Download
M include/codec/SkCodec.h View 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 8 chunks +74 lines, -18 lines 0 comments Download
M src/codec/SkAndroidCodec.cpp View 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 1 chunk +0 lines, -2 lines 0 comments Download
M src/codec/SkCodec.cpp View 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 4 chunks +3 lines, -18 lines 0 comments Download
A src/codec/SkCodecAnimation.h View 1 2 3 4 5 6 7 8 9 10 11 12 13 14 1 chunk +94 lines, -0 lines 0 comments Download
M src/codec/SkGifCodec.h View 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 4 chunks +76 lines, -124 lines 0 comments Download
M src/codec/SkGifCodec.cpp View 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 3 chunks +442 lines, -486 lines 0 comments Download
M src/codec/SkSampledCodec.cpp View 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 1 chunk +0 lines, -1 line 0 comments Download
A src/codec/SkStreamBuffer.h View 1 2 3 4 5 6 7 8 9 10 11 12 1 chunk +68 lines, -0 lines 0 comments Download
A src/codec/SkStreamBuffer.cpp View 1 2 3 4 5 6 7 8 9 10 11 12 1 chunk +23 lines, -0 lines 0 comments Download
M src/codec/SkSwizzler.h View 1 2 3 4 5 6 7 8 9 10 11 12 1 chunk +6 lines, -0 lines 0 comments Download
A tests/CodecAnimTest.cpp View 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 1 chunk +141 lines, -0 lines 0 comments Download
M tests/CodecPartialTest.cpp View 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 7 chunks +151 lines, -25 lines 0 comments Download
M tests/CodecTest.cpp View 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 4 chunks +70 lines, -6 lines 0 comments Download
M tests/GifTest.cpp View 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 1 chunk +1 line, -1 line 0 comments Download
A third_party/gif/GIFImageReader.h View 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 1 chunk +398 lines, -0 lines 0 comments Download
A third_party/gif/GIFImageReader.cpp View 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 1 chunk +941 lines, -0 lines 0 comments Download

Messages

Total messages: 98 (44 generated)
scroggo_chromium
Here's a first draft of an API for SkCodec that supports animation while leaving caching ...
3 years, 2 months ago (2016-09-21 19:30:28 UTC) #4
msarett
Just looked at the API. Very exciting! I wrote down a bunch of nits that ...
3 years, 2 months ago (2016-09-21 22:23:48 UTC) #5
cblume
I'm also very excited about this. This is great! https://codereview.chromium.org/2045293002/diff/20001/include/codec/SkCodec.h File include/codec/SkCodec.h (right): https://codereview.chromium.org/2045293002/diff/20001/include/codec/SkCodec.h#newcode293 include/codec/SkCodec.h:293: ...
3 years, 2 months ago (2016-09-22 01:08:47 UTC) #7
cblume
https://codereview.chromium.org/2045293002/diff/20001/include/codec/SkCodec.h File include/codec/SkCodec.h (right): https://codereview.chromium.org/2045293002/diff/20001/include/codec/SkCodec.h#newcode293 include/codec/SkCodec.h:293: bool fHasPriorFrame; On 2016/09/22 01:08:47, cblume wrote: > I ...
3 years, 2 months ago (2016-09-22 01:42:19 UTC) #8
joostouwerling
https://codereview.chromium.org/2045293002/diff/20001/include/codec/SkCodec.h File include/codec/SkCodec.h (right): https://codereview.chromium.org/2045293002/diff/20001/include/codec/SkCodec.h#newcode603 include/codec/SkCodec.h:603: size_t getFrameCount() { On 2016/09/22 01:08:47, cblume wrote: > ...
3 years, 2 months ago (2016-09-22 15:43:17 UTC) #9
cblume
On 2016/09/22 15:43:17, joostouwerling wrote: > https://codereview.chromium.org/2045293002/diff/20001/include/codec/SkCodec.h > File include/codec/SkCodec.h (right): > > https://codereview.chromium.org/2045293002/diff/20001/include/codec/SkCodec.h#newcode603 > ...
3 years, 2 months ago (2016-09-22 16:23:19 UTC) #10
scroggo
https://codereview.chromium.org/2045293002/diff/20001/include/codec/SkCodec.h File include/codec/SkCodec.h (right): https://codereview.chromium.org/2045293002/diff/20001/include/codec/SkCodec.h#newcode245 include/codec/SkCodec.h:245: : fZeroInitialized(kNo_ZeroInitialized) On 2016/09/21 22:23:48, msarett wrote: > I ...
3 years, 2 months ago (2016-09-22 16:46:43 UTC) #12
scroggo
FYI: I've added a design doc at https://docs.google.com/a/google.com/document/d/12Qhf9T92MWfdWujQwCIjhCO3sw6pTJB5pJBwDM1T7Kc/edit?usp=sharing
3 years, 2 months ago (2016-09-22 18:37:15 UTC) #13
cblume
https://codereview.chromium.org/2045293002/diff/20001/include/codec/SkCodec.h File include/codec/SkCodec.h (right): https://codereview.chromium.org/2045293002/diff/20001/include/codec/SkCodec.h#newcode293 include/codec/SkCodec.h:293: bool fHasPriorFrame; I agree with what you are saying. ...
3 years, 2 months ago (2016-09-22 21:29:02 UTC) #14
msarett
Started looking through the implementation...thinking out loud a little bit. https://codereview.chromium.org/2045293002/diff/60001/src/codec/SkCodecAnimation.h File src/codec/SkCodecAnimation.h (right): https://codereview.chromium.org/2045293002/diff/60001/src/codec/SkCodecAnimation.h#newcode41 ...
3 years, 2 months ago (2016-09-22 22:54:36 UTC) #15
scroggo
Patch set 5 fixes up a comment Matt pointed out. Patch set 6 experiments with ...
3 years, 2 months ago (2016-09-23 15:53:16 UTC) #16
cblume
https://codereview.chromium.org/2045293002/diff/20001/include/codec/SkCodec.h File include/codec/SkCodec.h (right): https://codereview.chromium.org/2045293002/diff/20001/include/codec/SkCodec.h#newcode293 include/codec/SkCodec.h:293: bool fHasPriorFrame; On 2016/09/23 15:53:15, scroggo wrote: > On ...
3 years, 2 months ago (2016-09-23 19:15:45 UTC) #17
scroggo
I don't think I'm going to get up another patch set that tries out the ...
3 years, 2 months ago (2016-09-23 21:15:00 UTC) #18
cblume
https://codereview.chromium.org/2045293002/diff/20001/include/codec/SkCodec.h File include/codec/SkCodec.h (right): https://codereview.chromium.org/2045293002/diff/20001/include/codec/SkCodec.h#newcode603 include/codec/SkCodec.h:603: size_t getFrameCount() { On 2016/09/23 21:15:00, scroggo wrote: > ...
3 years, 2 months ago (2016-09-23 23:31:32 UTC) #19
msarett
> Patch set 6 experiments with something reed@ suggested in person - returning all > ...
3 years, 2 months ago (2016-09-26 14:13:13 UTC) #20
scroggo
PTAL: I think returning the vector metadata in one call is the way to go. ...
3 years, 2 months ago (2016-09-26 15:51:43 UTC) #22
msarett
> PTAL: I think returning the vector metadata in one call is the way to ...
3 years, 2 months ago (2016-09-26 17:30:54 UTC) #23
scroggo
https://codereview.chromium.org/2045293002/diff/120001/include/codec/SkCodec.h File include/codec/SkCodec.h (right): https://codereview.chromium.org/2045293002/diff/120001/include/codec/SkCodec.h#newcode626 include/codec/SkCodec.h:626: * Number of 1/100 seconds to show this frame. ...
3 years, 2 months ago (2016-09-26 17:43:11 UTC) #24
scroggo_chromium
PTAL. Patch set 14 is ready for review. I've repurposed blink's GIFImageReader, and if you ...
3 years, 1 month ago (2016-10-13 20:38:16 UTC) #29
msarett
Looks good so far. Still need to look at GifImageReader and the rest of SkGifCodec. ...
3 years, 1 month ago (2016-10-14 14:58:51 UTC) #30
joostouwerling
https://codereview.chromium.org/2045293002/diff/260001/src/codec/GIFImageReader.cpp File src/codec/GIFImageReader.cpp (right): https://codereview.chromium.org/2045293002/diff/260001/src/codec/GIFImageReader.cpp#newcode415 src/codec/GIFImageReader.cpp:415: // GIFSizeQuery and GIFFrameCountQuery are negative, so this is ...
3 years, 1 month ago (2016-10-14 15:02:44 UTC) #31
cblume
https://codereview.chromium.org/2045293002/diff/260001/dm/DMSrcSink.cpp File dm/DMSrcSink.cpp (right): https://codereview.chromium.org/2045293002/diff/260001/dm/DMSrcSink.cpp#newcode447 dm/DMSrcSink.cpp:447: if (reqFrame != SkCodec::kIndependentFrame && reqFrame == cachedFrame I ...
3 years, 1 month ago (2016-10-14 16:52:36 UTC) #32
scroggo_chromium
https://codereview.chromium.org/2045293002/diff/260001/dm/DMSrcSink.cpp File dm/DMSrcSink.cpp (right): https://codereview.chromium.org/2045293002/diff/260001/dm/DMSrcSink.cpp#newcode447 dm/DMSrcSink.cpp:447: if (reqFrame != SkCodec::kIndependentFrame && reqFrame == cachedFrame On ...
3 years, 1 month ago (2016-10-14 19:56:00 UTC) #33
msarett
https://codereview.chromium.org/2045293002/diff/260001/gyp/codec.gyp File gyp/codec.gyp (left): https://codereview.chromium.org/2045293002/diff/260001/gyp/codec.gyp#oldcode20 gyp/codec.gyp:20: 'giflib.gyp:giflib', On 2016/10/14 19:55:59, scroggo_chromium wrote: > On 2016/10/14 ...
3 years, 1 month ago (2016-10-17 13:39:03 UTC) #34
scroggo_chromium
https://codereview.chromium.org/2045293002/diff/280001/src/codec/SkGifCodec.cpp File src/codec/SkGifCodec.cpp (right): https://codereview.chromium.org/2045293002/diff/280001/src/codec/SkGifCodec.cpp#newcode295 src/codec/SkGifCodec.cpp:295: // writeTransparentPixels will be false in this case, based ...
3 years, 1 month ago (2016-10-17 17:22:38 UTC) #35
scroggo_chromium
https://codereview.chromium.org/2045293002/diff/340001/BUILD.gn File BUILD.gn (right): https://codereview.chromium.org/2045293002/diff/340001/BUILD.gn#newcode347 BUILD.gn:347: "src/codec/GIFImageReader.cpp", I've clearly done something wrong here. When I ...
3 years, 1 month ago (2016-10-17 20:53:56 UTC) #36
scroggo_chromium
https://codereview.chromium.org/2045293002/diff/340001/BUILD.gn File BUILD.gn (right): https://codereview.chromium.org/2045293002/diff/340001/BUILD.gn#newcode347 BUILD.gn:347: "src/codec/GIFImageReader.cpp", On 2016/10/17 20:53:56, scroggo_chromium wrote: > I've clearly ...
3 years, 1 month ago (2016-10-17 21:16:19 UTC) #37
msarett
lgtm https://codereview.chromium.org/2045293002/diff/360001/BUILD.gn File BUILD.gn (right): https://codereview.chromium.org/2045293002/diff/360001/BUILD.gn#newcode343 BUILD.gn:343: public_defines = [ "SK_HAS_GIF_LIBRARY" ] Now that we ...
3 years, 1 month ago (2016-10-18 20:04:36 UTC) #38
scroggo_chromium
https://codereview.chromium.org/2045293002/diff/360001/BUILD.gn File BUILD.gn (right): https://codereview.chromium.org/2045293002/diff/360001/BUILD.gn#newcode343 BUILD.gn:343: public_defines = [ "SK_HAS_GIF_LIBRARY" ] On 2016/10/18 20:04:36, msarett ...
3 years, 1 month ago (2016-10-18 20:41:47 UTC) #39
scroggo_chromium
reed@, can you take a look at the public API?
3 years, 1 month ago (2016-10-18 20:42:20 UTC) #42
commit-bot: I haz the power
CQ is trying da patch. Follow status at https://chromium-cq-status.appspot.com/v2/patch-status/codereview.chromium.org/2045293002/420001
3 years, 1 month ago (2016-10-18 21:10:00 UTC) #47
commit-bot: I haz the power
Try jobs failed on following builders: Build-Mac-Clang-x86_64-Release-GN-Trybot on master.client.skia.compile (JOB_FAILED, http://build.chromium.org/p/client.skia.compile/builders/Build-Mac-Clang-x86_64-Release-GN-Trybot/builds/2265) skia_presubmit-Trybot on master.client.skia.fyi (JOB_FAILED, ...
3 years, 1 month ago (2016-10-18 21:12:07 UTC) #49
cblume
https://codereview.chromium.org/2045293002/diff/260001/dm/DMSrcSink.cpp File dm/DMSrcSink.cpp (right): https://codereview.chromium.org/2045293002/diff/260001/dm/DMSrcSink.cpp#newcode447 dm/DMSrcSink.cpp:447: if (reqFrame != SkCodec::kIndependentFrame && reqFrame == cachedFrame On ...
3 years, 1 month ago (2016-10-18 21:57:32 UTC) #50
reed1
1. nice cl comment -- paste it into a design doc? 2. can we just ...
3 years, 1 month ago (2016-10-20 17:00:19 UTC) #51
scroggo_chromium
On 2016/10/20 17:00:19, reed1 wrote: > 1. nice cl comment -- paste it into a ...
3 years, 1 month ago (2016-10-20 17:57:13 UTC) #57
msarett
https://codereview.chromium.org/2045293002/diff/500001/src/codec/SkGifCodec.cpp File src/codec/SkGifCodec.cpp (right): https://codereview.chromium.org/2045293002/diff/500001/src/codec/SkGifCodec.cpp#newcode97 src/codec/SkGifCodec.cpp:97: const auto alphaType = reader->firstFrameHasAlpha() ? kPremul_SkAlphaType Can we ...
3 years, 1 month ago (2016-10-20 18:20:37 UTC) #58
scroggo
On 2016/10/20 17:00:19, reed1 wrote: > 2. can we just add fFrameIndex and fHasPrevFrame into ...
3 years, 1 month ago (2016-10-20 18:34:11 UTC) #59
msarett
Still lgtm
3 years, 1 month ago (2016-10-20 20:33:24 UTC) #60
cblume
lgtm
3 years, 1 month ago (2016-10-21 20:11:07 UTC) #61
reed1
lgtm
3 years, 1 month ago (2016-10-24 13:10:58 UTC) #62
commit-bot: I haz the power
CQ is trying da patch. Follow status at https://chromium-cq-status.appspot.com/v2/patch-status/codereview.chromium.org/2045293002/580001
3 years, 1 month ago (2016-10-24 13:14:13 UTC) #66
commit-bot: I haz the power
Try jobs failed on following builders: skia_presubmit-Trybot on master.client.skia.fyi (JOB_FAILED, http://build.chromium.org/p/client.skia.fyi/builders/skia_presubmit-Trybot/builds/15222)
3 years, 1 month ago (2016-10-24 13:15:46 UTC) #68
commit-bot: I haz the power
CQ is trying da patch. Follow status at https://chromium-cq-status.appspot.com/v2/patch-status/codereview.chromium.org/2045293002/600001
3 years, 1 month ago (2016-10-24 13:55:13 UTC) #71
commit-bot: I haz the power
Try jobs failed on following builders: Build-Ubuntu-Clang-x86_64-Debug-GN-Trybot on master.client.skia.compile (JOB_FAILED, http://build.chromium.org/p/client.skia.compile/builders/Build-Ubuntu-Clang-x86_64-Debug-GN-Trybot/builds/2381)
3 years, 1 month ago (2016-10-24 13:57:24 UTC) #73
commit-bot: I haz the power
CQ is trying da patch. Follow status at https://chromium-cq-status.appspot.com/v2/patch-status/codereview.chromium.org/2045293002/620001
3 years, 1 month ago (2016-10-24 14:35:07 UTC) #76
commit-bot: I haz the power
Try jobs failed on following builders: Build-Mac-Clang-x86_64-Release-GN-Trybot on master.client.skia.compile (JOB_FAILED, http://build.chromium.org/p/client.skia.compile/builders/Build-Mac-Clang-x86_64-Release-GN-Trybot/builds/2384)
3 years, 1 month ago (2016-10-24 14:38:35 UTC) #78
commit-bot: I haz the power
CQ is trying da patch. Follow status at https://chromium-cq-status.appspot.com/v2/patch-status/codereview.chromium.org/2045293002/640001
3 years, 1 month ago (2016-10-24 14:46:54 UTC) #81
commit-bot: I haz the power
Try jobs failed on following builders: Build-Win-MSVC-x86-Debug-Trybot on master.client.skia.compile (JOB_FAILED, http://build.chromium.org/p/client.skia.compile/builders/Build-Win-MSVC-x86-Debug-Trybot/builds/12666)
3 years, 1 month ago (2016-10-24 14:52:44 UTC) #83
commit-bot: I haz the power
CQ is trying da patch. Follow status at https://chromium-cq-status.appspot.com/v2/patch-status/codereview.chromium.org/2045293002/660001
3 years, 1 month ago (2016-10-24 15:07:42 UTC) #86
commit-bot: I haz the power
Try jobs failed on following builders: Build-Win-MSVC-x86-Debug-Trybot on master.client.skia.compile (JOB_FAILED, http://build.chromium.org/p/client.skia.compile/builders/Build-Win-MSVC-x86-Debug-Trybot/builds/12667)
3 years, 1 month ago (2016-10-24 15:13:52 UTC) #88
commit-bot: I haz the power
CQ is trying da patch. Follow status at https://chromium-cq-status.appspot.com/v2/patch-status/codereview.chromium.org/2045293002/680001
3 years, 1 month ago (2016-10-24 15:15:53 UTC) #91
commit-bot: I haz the power
Try jobs failed on following builders: Test-Ubuntu-GCC-GCE-CPU-AVX2-x86_64-Debug-GN-Trybot on master.client.skia (JOB_FAILED, http://build.chromium.org/p/client.skia/builders/Test-Ubuntu-GCC-GCE-CPU-AVX2-x86_64-Debug-GN-Trybot/builds/2233)
3 years, 1 month ago (2016-10-24 15:24:42 UTC) #93
commit-bot: I haz the power
CQ is trying da patch. Follow status at https://chromium-cq-status.appspot.com/v2/patch-status/codereview.chromium.org/2045293002/700001
3 years, 1 month ago (2016-10-24 15:35:02 UTC) #96
commit-bot: I haz the power
3 years, 1 month ago (2016-10-24 16:03:30 UTC) #98
Message was sent while issue was closed.
Committed patchset #36 (id:700001) as
https://skia.googlesource.com/skia/+/19b91531e912283d237435d94516575b28713cba

Powered by Google App Engine
This is Rietveld 408576698